
package fast;

import java.util.HashMap;
import java.util.Random;

import at.mabs.util.cuckoo.CIntHashMap;

import com.google.caliper.Param;
import com.google.caliper.SimpleBenchmark;

import fast.maps.Cuckoo3;
import fast.maps.Cuckoo3Stash;

public class CuckooPut8 extends SimpleBenchmark {
	@Param int count;
	@Param int initialCapacity;
	@Param float loadFactor;

	int[] randomInt;
	final Object value = new Object();

	HashMap hashMap_Java;
	CIntHashMap cIntHashMap_delt0r;
	Cuckoo3 cuckoo3_Nate;
	Cuckoo3Stash cuckoo3Stash_Nate;

	protected void setUp () throws Exception {
		randomInt = new int[count];
		Random r = new Random();
		for (int i = 0; i < count; i++) {
			int value = -1;
			while (value == -1)
				value = r.nextInt();
			randomInt[i] = value;
		}

		hashMap_Java = new HashMap(count, loadFactor);
		cIntHashMap_delt0r = new CIntHashMap(initialCapacity, loadFactor);
		cuckoo3_Nate = new Cuckoo3(initialCapacity, loadFactor);
		cuckoo3Stash_Nate = new Cuckoo3Stash(initialCapacity, loadFactor);
	}

	public void timeHashMap_Java (int reps) {
		for (int rep = 0; rep < reps; rep++) {
			for (int i = 0; i < count; i++)
				hashMap_Java.put(randomInt[i], value);
			hashMap_Java.clear();
		}
	}

	public void timeCIntHashMap_delt0r (int reps) {
		for (int rep = 0; rep < reps; rep++) {
			for (int i = 0; i < count; i++)
				cIntHashMap_delt0r.put(randomInt[i], value);
			cIntHashMap_delt0r.clear();
		}
	}

	public void timeCuckoo3Stash_Nate (int reps) {
		for (int rep = 0; rep < reps; rep++) {
			for (int i = 0; i < count; i++)
				cuckoo3Stash_Nate.put(randomInt[i], value);
			cuckoo3Stash_Nate.clear();
		}
	}

	public void timeCuckoo3_Nate (int reps) {
		for (int rep = 0; rep < reps; rep++) {
			for (int i = 0; i < count; i++)
				cuckoo3_Nate.put(randomInt[i], value);
			cuckoo3_Nate.clear();
		}
	}
}
