
package fast;

import java.util.Random;

import at.mabs.util.cuckoo.CIntHashMap;
import cern.colt.map.OpenIntObjectHashMap;

import com.google.caliper.Param;
import com.google.caliper.SimpleBenchmark;

import fast.maps.FastIntMap;
import fast.maps.IntMap;
import fast.maps.IntMap2;
import fast.other.ApacheIntHashMap;
import gnu.trove.map.hash.TIntObjectHashMap;

public class IntMapGet extends SimpleBenchmark {
	@Param int count;

	int[] randomInt;
	final Object value = new Object();

	FastIntMap fastIntMap_Nate;
	TIntObjectHashMap tIntObjectHashMap_Trove;
	OpenIntObjectHashMap openIntObjectHashMap_Cern;
	ApacheIntHashMap apacheIntHashMap_CommonsLang;
	IntMap intMap_Nate;
	CIntHashMap cIntHashMap_d3ltor;
	IntMap2 intMap2_Nate;

	protected void setUp () throws Exception {
		randomInt = new int[count];
		Random r = new Random();
		for (int i = 0; i < count; i++) {
			int value = -1;
			while (value == -1)
				value = r.nextInt();
			randomInt[i] = value;
		}

		fastIntMap_Nate = new FastIntMap(count);
		for (int i = 0; i < count; i++)
			fastIntMap_Nate.put(randomInt[i], value);

		tIntObjectHashMap_Trove = new TIntObjectHashMap(count);
		for (int i = 0; i < count; i++)
			tIntObjectHashMap_Trove.put(randomInt[i], value);

		openIntObjectHashMap_Cern = new OpenIntObjectHashMap(count);
		for (int i = 0; i < count; i++)
			openIntObjectHashMap_Cern.put(randomInt[i], value);

		apacheIntHashMap_CommonsLang = new ApacheIntHashMap(count);
		for (int i = 0; i < count; i++)
			apacheIntHashMap_CommonsLang.put(randomInt[i], value);

		intMap_Nate = new IntMap(count);
		for (int i = 0; i < count; i++)
			intMap_Nate.put(randomInt[i], value);

		intMap2_Nate = new IntMap2(count);
		for (int i = 0; i < count; i++)
			intMap2_Nate.put(randomInt[i], value);

		cIntHashMap_d3ltor = new CIntHashMap(count, 0.6f);
		for (int i = 0; i < count; i++)
			cIntHashMap_d3ltor.put(randomInt[i], value);
	}

	public void timeFastIntMap_Nate (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				fastIntMap_Nate.get(randomInt[i]);
	}

	public void timeTIntObjectHashMap_Trove (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				tIntObjectHashMap_Trove.get(randomInt[i]);
	}

	public void timeOpenIntObjectHashMap_Cern (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				openIntObjectHashMap_Cern.get(randomInt[i]);
	}

	public void timeApacheIntHashMap_CommonsLang (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				apacheIntHashMap_CommonsLang.get(randomInt[i]);
	}

	public void timeIntMap_Nate (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				intMap_Nate.get(randomInt[i]);
	}

	public void timeIntMap2_Nate (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				intMap2_Nate.get(randomInt[i]);
	}

	public void timeCIntHashMap_d3ltor (int reps) {
		for (int rep = 0; rep < reps; rep++)
			for (int i = 0; i < count; i++)
				cIntHashMap_d3ltor.get(randomInt[i]);
	}
}
